package betterwithmods.common.entity;

import betterwithmods.BWMod;
import net.minecraft.block.BlockLeaves;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.monster.EntityCaveSpider;
import net.minecraft.init.Blocks;
import net.minecraft.init.MobEffects;
import net.minecraft.potion.PotionEffect;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.EnumDifficulty;
import net.minecraft.world.EnumSkyBlock;
import net.minecraft.world.World;
import net.minecraft.world.storage.loot.LootTableList;

import javax.annotation.Nullable;

public class EntityJungleSpider extends EntityCaveSpider {
    public static final ResourceLocation LOOT = LootTableList.func_186375_a(new ResourceLocation(BWMod.MODID, "entity/jungle_spider"));

    public EntityJungleSpider(World worldIn) {
        super(worldIn);
    }

    @Override
    public boolean func_70652_k(Entity entityIn) {
        if (super.func_70652_k(entityIn))
        {
            if (entityIn instanceof EntityLivingBase)
            {
                int duration = 0;

                if (this.field_70170_p.func_175659_aa() == EnumDifficulty.NORMAL)
                {
                    duration = 7;
                }
                else if (this.field_70170_p.func_175659_aa() == EnumDifficulty.HARD)
                {
                    duration = 15;
                }

                if (duration > 0)
                {
                    ((EntityLivingBase)entityIn).func_70690_d(new PotionEffect(MobEffects.field_76438_s, duration * 20, 0));
                }
            }

            return true;
        }
        else
        {
            return false;
        }
    }

    @Nullable
    @Override
    protected ResourceLocation func_184647_J() {
        return LOOT;
    }

    @Override
    protected boolean func_70814_o() {
        BlockPos blockpos = new BlockPos(this.field_70165_t, this.func_174813_aQ().field_72338_b, this.field_70161_v);

        if (this.field_70170_p.func_175642_b(EnumSkyBlock.BLOCK, blockpos) > 7)
        {
            return false;
        }

        return true;
    }

    @Override
    public boolean func_70601_bi() {
        BlockPos pos = new BlockPos(this.field_70165_t, this.func_174813_aQ().field_72338_b, this.field_70161_v);
        IBlockState topBlock = field_70170_p.func_180495_p(field_70170_p.func_175645_m(pos).func_177977_b());

        if(topBlock.func_177230_c() == Blocks.field_150362_t && topBlock.func_177229_b(BlockLeaves.field_176237_a)) {
            this.func_70107_b(field_70165_t,field_70170_p.func_175645_m(pos).func_177956_o() - 2 - field_70146_Z.nextInt(32),field_70161_v);
            return super.func_70601_bi();
        }

        return false;
    }
}
