package betterwithmods.module.tweaks;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.BlockUnfiredPottery;
import betterwithmods.common.blocks.tile.TileCamo;
import betterwithmods.common.items.ItemMaterial;
import betterwithmods.common.registry.blockmeta.managers.KilnManager;
import betterwithmods.common.registry.blockmeta.recipe.KilnRecipe;
import betterwithmods.module.Feature;
import com.google.common.collect.Lists;
import com.mojang.authlib.GameProfile;
import net.minecraft.block.*;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class PlaceClay extends Feature {


    @Override
    public String getFeatureDescription() {
        return "Clay and Nether Sludge are placeable blocks.";
    }

    @Override
    public void init(FMLInitializationEvent event) {
        KilnManager.INSTANCE.addRecipe(new KilnRecipe(BWMBlocks.UNFIRED_POTTERY, BlockUnfiredPottery.EnumType.BRICK.getMeta(), Lists.newArrayList(new ItemStack(Items.field_151118_aC))) {
            @Override
            public ItemStack getStack() {
                return new ItemStack(Items.field_151119_aD);
            }
        });
        KilnManager.INSTANCE.addRecipe(new KilnRecipe(BWMBlocks.UNFIRED_POTTERY, BlockUnfiredPottery.EnumType.NETHER_BRICK.getMeta(), Lists.newArrayList(new ItemStack(Items.field_151130_bT))) {
            @Override
            public ItemStack getStack() {
                return ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.NETHER_SLUDGE);
            }
        });

    }


    @SubscribeEvent
    public void onPlaceClay(PlayerInteractEvent.RightClickBlock event) {
        if (event.isCanceled())
            return;


        if (event.getItemStack().func_77969_a(new ItemStack(Items.field_151119_aD))) {
            if (canPlaceAt(event.getEntityPlayer(), event.getWorld(), event.getPos())) {
                PlayerContainer container = new PlayerContainer(event.getEntityPlayer(), BlockUnfiredPottery.getStack(BlockUnfiredPottery.EnumType.BRICK));
                ItemBlock item = (ItemBlock) Item.func_150898_a(BWMBlocks.UNFIRED_POTTERY);
                EnumActionResult result = item.func_180614_a(container, event.getWorld(), event.getPos(), event.getHand(), event.getFace(), (float) event.getHitVec().field_72450_a, (float) event.getHitVec().field_72448_b, (float) event.getHitVec().field_72449_c);
                if (result == EnumActionResult.SUCCESS) {
                    event.getEntityPlayer().func_184609_a(event.getHand());
                }
            }
        }

        if (event.getItemStack().func_77969_a(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.NETHER_SLUDGE))) {
            if (canPlaceAt(event.getEntityPlayer(), event.getWorld(), event.getPos())) {
                PlayerContainer container = new PlayerContainer(event.getEntityPlayer(), BlockUnfiredPottery.getStack(BlockUnfiredPottery.EnumType.NETHER_BRICK));
                ItemBlock item = (ItemBlock) Item.func_150898_a(BWMBlocks.UNFIRED_POTTERY);
                EnumActionResult result = item.func_180614_a(container, event.getWorld(), event.getPos(), event.getHand(), event.getFace(), (float) event.getHitVec().field_72450_a, (float) event.getHitVec().field_72448_b, (float) event.getHitVec().field_72449_c);
                if (result == EnumActionResult.SUCCESS) {
                    event.getEntityPlayer().func_184609_a(event.getHand());
                }
            }
        }
        
    }

    private boolean canPlaceAt(EntityPlayer player, World world, BlockPos pos) {
        if (player.func_70093_af())
            return true;
        TileEntity tile = world.func_175625_s(pos);
        if (tile != null && !(tile instanceof TileCamo))
            return false;
        IBlockState state = world.func_180495_p(pos);
        Block block = state.func_177230_c();
        return !(block instanceof BlockWorkbench || block instanceof BlockDoor || block instanceof BlockTrapDoor || block instanceof BlockFenceGate);
    }


    @Override
    public boolean hasSubscriptions() {
        return true;
    }

    @SuppressWarnings("EntityConstructor")
    private class PlayerContainer extends EntityPlayer {
        private EntityPlayer player;
        private ItemStack held;

        public PlayerContainer(World worldIn, GameProfile gameProfileIn) {
            super(worldIn, gameProfileIn);
        }

        public PlayerContainer(EntityPlayer player, ItemStack held) {
            super(player.func_130014_f_(), player.func_146103_bH());
            this.player = player;
            this.held = held;
        }

        @Override
        public boolean func_175149_v() {
            return player.func_175149_v();
        }

        @Override
        public boolean func_184812_l_() {
            return player.func_184812_l_();
        }

        @Override
        public ItemStack func_184586_b(EnumHand hand) {
            return held;
        }

        @Override
        public boolean func_175151_a(BlockPos pos, EnumFacing facing, ItemStack stack) {
            return player.func_175151_a(pos, facing, stack);
        }
    }
}
